! #gfortran44 -o ascii_to_bin_topo.exe ascii_to_bin_topo.f90 write_geogrid.o
! #./ascii_to_bin_topo.exe

program ascii_to_bin_topo

  implicit none

  integer :: i,j
  integer :: isigned,endian,wordsize
  integer :: nx,ny,nz
  character*25 :: head12
  real :: scalefactor
  real*8 :: xllcorner, yllcorner, cellsize, missvalue

  real, allocatable :: rarray(:,:), iarray(:,:)

  isigned = 0
  endian = 0
  wordsize = 2
  scalefactor = 1
  nz = 1
 
  open(10, file = '1s_aster_12240x10800/topo/WRFCOSMOsmoothedboundaries_imax1500_cosmo-le-360_head.txt')
  
  read(10,*) head12, nx
  read(10,*) head12, ny
  read(10,*) head12, xllcorner
  read(10,*) head12, yllcorner
  read(10,*) head12, cellsize
  read(10,*) head12, missvalue

  allocate (rarray(nx,ny))
  allocate (iarray(nx,ny))

  do j= 1,ny
    read(10,*) iarray(:,j)
  end do

  ! reverse the data so that it begins at the lower left corner

  do j = 1,ny
    rarray(:,j) = iarray(:,ny-(j-1))
  end do

  call write_geogrid(rarray, nx, ny, nz, isigned, endian, scalefactor, wordsize)
  print *, nx,ny
  print*,'R',rarray(1,1),rarray(nx,ny)
  deallocate (rarray)

end program ascii_to_bin_topo
